import { Component, OnInit, ViewChild } from '@angular/core';
import { STColumn, STComponent } from '@delon/abc/st';
import { SFComponent, SFDateWidgetSchema, SFSchema, SFSelectWidgetSchema, SFUISchema } from '@delon/form';
import { ModalHelper, _HttpClient } from '@delon/theme';
import { NzModalService } from 'ng-zorro-antd/modal';
import { map } from 'rxjs/operators';
import { SupplyManagementService } from '../../services/order-management.service';


@Component({
  selector: 'app-supply-management-complaint',
  templateUrl: './complaint.component.html',
  styleUrls: ['./complaint.component.less']
})
export class OrderManagementComplaintComponent implements OnInit {
  url = `/user?_allow_anonymous=true`;
  ui: SFUISchema = {};
  uiView: SFUISchema = {};
  schema: SFSchema = {};
  schemaView: SFSchema = {};
  auditMany = false;
  isVisibleRE = false;
  _$expand = false;
  @ViewChild('st') private readonly st!: STComponent;
  @ViewChild('sf', { static: false }) sf!: SFComponent;
  @ViewChild('sfView', { static: false }) sfView!: SFComponent;
  columns: STColumn[] = [];
  datass: any = [
    {
    one: '1',
    two: '1',
    three: '1',
    id: 1
   },
    {
    one: '2',
    two: '2',
    three: '2',
    id: 2
   },
];
  tabs = [  {
    name: '全部',
    type: 5,
    count: 0,
  },
  {
    name: '待处理',
    type: 5,
    count: 0,
  },
  {
    name: '已处理',
    type: 5,
    count: 0,
  },
  {
    name: '已撤销',
    type: 5,
    count: 0,
  }
  ];
  constructor(public service: SupplyManagementService, private modal: NzModalService) { }

  /**
 * 查询参数
 */
  get reqParams() {
    return {
      ...this.sf?.value,
    };
  }
  get selectedRows() {
    return this.st?.list.filter((item) => item.checked) || [];
  }
  ngOnInit(): void {
    this.initSF();
    this.initST();
    this.initSTAudit();
  }



  /**
 * 初始化查询表单
 */
  initSF() {
    this.schema = {
      properties: {
        no: {
          type: 'string',
          title: '投诉单号',
        },
        createTime: {
          title: '投诉时间',
          type: 'string',
          ui: {
            widget: 'date',
            mode: 'range',
            format: 'yyyy-MM-dd',
          } as SFDateWidgetSchema,
        },
      },
    };
    this.ui = { '*': { spanLabelFixed: 110, grid: { span: 8, gutter: 4 } } };
  }

  /**
   * 初始化数据列表
   */
  initST() {
    this.columns = [
      {
        title: '投诉单号',
        width: '100px',
        className: 'text-center',
        render: 'goodsId'
      },
      {
        title: '运单号',
        width: '100px',
        className: 'text-center',
        render: 'goodsId'
      },
      {
        title: '投诉时间',
        width: '100px',
        className: 'text-center',
      },
      { title: '托运方', index: 'externalSn', width: '120px', className: 'text-center' },
      { title: '司机', index: 'linkUrl', width: '120px', className: 'text-center' },
      {
        title: '投诉原因',
        className: 'text-center',
        width: '120px',
      },
      {
        title: '投诉状态',
        className: 'text-center',
        width: '120px',
      }, {
        title: '处理结果',
        className: 'text-center',
        width: '120px',
      },
      {
        title: '投诉方',
        className: 'text-center',
        width: '120px',
      },
      {
        title: '投诉人',
        className: 'text-center',
        width: '120px',
      },
      {
        title: '操作',
        fixed: 'right',
        width: '200px',
        className: 'text-left',
        buttons: [
          {
            text: '处理',
            click: (_record) => this.viewEvaluate(_record),
          },
          {
            text: '查看',
            click: (_record) => this.viewEvaluate(_record),
          },
        ],
      },
    ];
  }
  initSTAudit() {
    this.schemaView = {
      properties: {
        roleDescription: {
          title: '处理结果',
          type: 'string',
          maxLength: 50,
          ui: {
            placeholder: '最多不超过50字',
            widget: 'textarea',
            autosize: { minRows: 3, maxRows: 6 }
          },
        },
      },
    };
    this.uiView = { '*': { spanLabelFixed: 110, grid: { span: 24 } } };
  }
  /**
   * 查询字段个数
   */
  get queryFieldCount(): number {
    return Object.keys(this.schema?.properties || {}).length;
  }
  /**
  * 伸缩查询条件
  */
  expandToggle(): void {
    this._$expand = !this._$expand;
    this.sf?.setValue('/_$expand', this._$expand);
  }
  tabChange(item: any) {
    console.log(item)
  }
  /**
   * 重置表单
   */
  resetSF(): void {
    this.sf.reset();
    this._$expand = false;
  }



  // 获取录单员 
  getCatalogueMember() {
    const params = {
    };
    return this.service.request(this.service.$api_get_catalogue_member, params, 'GET').pipe(
      map((res) => {
        if (res) {
          console.log(res)
        }
      }),
    );
  }

  selectChange(e: number) {
    console.log(e);
  }
  /**
   * 导入货源
   */
  importGoodsSource() {

  }
  audit(item: any) {
    console.log(item)
  }

 /*
  * 审核关闭弹窗
  view: 1
  浮动费用： 0
  查看评价： 3
  */
  handleCancel(type: string) {
    console.log(type)
    this.isVisibleRE = false
  }
    /**
  * 审核通过按钮
  */
  handleOK() {
    
  }
   /**
  *查看评价
  */
  viewEvaluate(item: any) {
    this.isVisibleRE = true
  }
}
